package aexp.calculator;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.util.Log;

public class Calculator extends Activity {
    EditText num1;
    EditText num2;
    TextView msg;
    enum Ops {
        ADD,
        SUBTRACT,
        MULTIPLY,
        DIVIDE,
    }
    static final String LOG_TAG = "Calculator2";

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.calculator);
        num1 = (EditText)findViewById( R.id.num1 );
        num2 = (EditText)findViewById( R.id.num2 );
        msg = (TextView)findViewById( R.id.error_message );
        Button addButton = (Button)findViewById( R.id.add_button );
        addButton.setOnClickListener( new View.OnClickListener() {
            public void onClick( View view ) {
                calculate( Ops.ADD );
            }
        } );
        Button subtractButton = (Button)findViewById( R.id.subtract_button );
        subtractButton.setOnClickListener( new View.OnClickListener() {
            public void onClick( View view ) {
                calculate( Ops.SUBTRACT );
            }
        } );
        Button multiplyButton = (Button)findViewById( R.id.multiply_button );
        multiplyButton.setOnClickListener( new View.OnClickListener() {
            public void onClick( View view ) {
                calculate( Ops.MULTIPLY );
            }
        } );
        Button divideButton = (Button)findViewById( R.id.divide_button );
        divideButton.setOnClickListener( new View.OnClickListener() {
            public void onClick( View view ) {
                calculate( Ops.DIVIDE );
            }
        } );
    }

    private void calculate( Ops operation ) {
        String num1String = num1.getText().toString();
        String num2String = num2.getText().toString();
        String message = null;
        double result = 0.0;
        try {
            message = "Illegal number: '"+num1String+"'";
            double d1 = Double.parseDouble( num1String );
            message = "Illegal number: '"+num2String+"'";
            double d2 = Double.parseDouble( num2String );
            message = null;

            switch( operation ) {
                case ADD:
                    result = d1 + d2;
                    break;

                case SUBTRACT:
                    result = d1 - d2;
                    break;

                case MULTIPLY:
                    result = d1 * d2;
                    break;

                case DIVIDE:
                    if( d2 == 0 )
                        message = "divisor is 0";
                    else
                        result = d1 / d2;
                    break;
            }
        } catch( NumberFormatException ex ) {
        }
        if( message != null )
            msg.setText( message );
        else {
            num1.setText( Double.toString( result ) );
            msg.setText( "" );
        }
    }
}
