package aexp.calculator.tests;

import android.test.ActivityInstrumentationTestCase;
import android.test.InstrumentationTestSuite;
import android.view.KeyEvent;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.util.Log;
import aexp.calculator.Calculator;
import aexp.calculator.R;

public class AddFunctionalTests 
            extends ActivityInstrumentationTestCase<Calculator> {
    Calculator calculatorInstance;
    EditText num1,num2;
    TextView msg;
    static final String LOG_TAG = "AddFunctionalTests";

    public AddFunctionalTests() {
        super("aexp.calculator", Calculator.class);
    }

    @Override
    protected void setUp() throws Exception {
        super.setUp();
        Calculator calculatorInstance = getActivity();
        num1 = (EditText)calculatorInstance.findViewById( R.id.num1 );
        num2 = (EditText)calculatorInstance.findViewById( R.id.num2 );
        msg = (TextView)calculatorInstance.findViewById( R.id.error_message );
    }

    static final String TESTSIMPLEADD_EXPECTED_RESULT = "2.9";
    static final String TESTSIMPLEADD_EXPECTED_MESSAGE = "";

    public void testSimpleAdd() {
        Log.d( LOG_TAG,"testSimpleAdd started" );

// First field
        sendKeys( KeyEvent.KEYCODE_1 );
        sendKeys( KeyEvent.KEYCODE_PERIOD );
        sendKeys( KeyEvent.KEYCODE_5 );
// move to the second field
        sendKeys( KeyEvent.KEYCODE_DPAD_DOWN );
        sendKeys( KeyEvent.KEYCODE_1 );
        sendKeys( KeyEvent.KEYCODE_PERIOD );
        sendKeys( KeyEvent.KEYCODE_4 );
// move to the '+' button
        sendKeys( KeyEvent.KEYCODE_DPAD_DOWN );
        sendKeys( KeyEvent.KEYCODE_DPAD_CENTER );

// Wait for the activity to finish all of its processing.
        getInstrumentation().waitForIdleSync();

        String result = num1.getText().toString();
        String message = msg.getText().toString();
        Log.d( LOG_TAG, "result: '"+result+"'" );
        Log.d( LOG_TAG, "message: '"+message+"'" );
        assertEquals( "num1 field", TESTSIMPLEADD_EXPECTED_RESULT, result );
        assertEquals( "msg field",TESTSIMPLEADD_EXPECTED_MESSAGE, message );

        // Retrieve the text we should have written...
        Log.d( LOG_TAG,"testSimpleAdd stopped" );        
    }

    static final String TESTADDERROR_EXPECTED_RESULT = "1.1";
    static final String TESTADDERROR_EXPECTED_MESSAGE = "Illegal number: ''";

    public void testAddError() {
        Log.d( LOG_TAG,"testAddError started" );

// First field
        sendKeys( KeyEvent.KEYCODE_1 );
        sendKeys( KeyEvent.KEYCODE_PERIOD );
        sendKeys( KeyEvent.KEYCODE_1 );
// move to the second field and leave that empty
        sendKeys( KeyEvent.KEYCODE_DPAD_DOWN );

// move to the '+' button
        sendKeys( KeyEvent.KEYCODE_DPAD_DOWN );
        sendKeys( KeyEvent.KEYCODE_DPAD_CENTER );

// Wait for the activity to finish all of its processing.
        getInstrumentation().waitForIdleSync();

        String result = num1.getText().toString();
        String message = msg.getText().toString();
        Log.d( LOG_TAG, "result: '"+result+"'" );
        Log.d( LOG_TAG, "message: '"+message+"'" );
        assertEquals( "num1 field",TESTADDERROR_EXPECTED_RESULT, result  );
        assertEquals( "msg field", TESTADDERROR_EXPECTED_MESSAGE, message );

        // Retrieve the text we should have written...
        Log.d( LOG_TAG,"testAddError stopped" );        
    }
}
